import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class CursorStack<T> {
	Node<T>[] cursorArray = new Node[101];

	public CursorStack() {
		this.initialization();
	}

	public int initialization() {
		for (int i = 0; i < cursorArray.length - 1; i++)
			cursorArray[i] = new Node<T>(null, i + 1);
		cursorArray[cursorArray.length - 1] = new Node<>(null, 0);
		return 0;
	}

	public int malloc() {
		int p = cursorArray[0].getNext();
		cursorArray[0].setNext(cursorArray[p].getNext());
		return p;
	}

	public void free(int p) {
		cursorArray[p] = new Node<T>(null, cursorArray[0].getNext());
		cursorArray[0].setNext(p);
	}

	public boolean isNull(int l) {
		return cursorArray[l] == null;
	}

	public boolean isEmpty(int l) {
		return cursorArray[l].getNext() == 0;
	}

	public boolean isLast(int p) {
		return cursorArray[p].getNext() == 0;
	}

	public T getFirst(int l) {
		int first = cursorArray[l].getNext();
		if (first != 0)
			return cursorArray[first].getData();
		else
			return null;
	}

	public int createList() {
		int l = malloc();
		if (l == 0)
			System.out.println("Error: Out of space!!!");
		else
			cursorArray[l] = new Node("-", 0);
		return l;
	}

	// insert At Head
	public void push(T data, int l) {
		if (isNull(l)) // list not created
			return;
		int p = malloc();
		if (p != 0) {
			cursorArray[p] = new Node(data, cursorArray[l].getNext());
			cursorArray[l].setNext(p);
		} else
			System.out.println("Error: Out of space!!!");
	}

	// delete At Head
	public Node<T> pop(int l) {
		if (cursorArray[l].getNext() == 0) // list not created
			return null;
		else {
			int p = cursorArray[l].getNext();
			T deletedData = cursorArray[p].getData();
			cursorArray[l].setNext(cursorArray[p].getNext());

			free(p);
			Node<T> moh = new Node(deletedData, 0);
			return moh;

		}
	}

	public void traversList(int l) {
		// System.out.print("list=" + l + "\n");
		while (!isNull(l) && !isEmpty(l)) {
			l = cursorArray[l].getNext();
			System.out.println(cursorArray[l]);
		}
	}

	public int find(T data, int l) {
		while (!isNull(l) && !isEmpty(l)) {
			l = cursorArray[l].getNext();
			if (cursorArray[l].getData().equals(data))
				return l;
		}
		return -1; // not found
	}

	public int findPrevious(T data, int l) {
		while (!isNull(l) && !isEmpty(l)) {
			if (cursorArray[cursorArray[l].getNext()].getData().equals(data))
				return l;
			l = cursorArray[l].getNext();
		}
		return -1; // not found
	}

	public Node<T> delete(T data, int l) {
		int p = findPrevious(data, l);
		if (p != -1) {
			int c = cursorArray[p].getNext();
			Node<T> temp = cursorArray[c];
			cursorArray[p].setNext(temp.getNext());
			free(c);
		}
		return null;
	}

	public void writeToFile(int l) throws FileNotFoundException {
		File file = new File("output.txt");
		PrintWriter output = new PrintWriter(file);
		while (!(isNull(l)) && !(isEmpty(l))) {
			l = cursorArray[l].getNext();
			output.println(cursorArray[l]);
			output.println(
					"________________________________________________________________________________________________________________________________________________________________________________\n");
			output.println();

			// System.out.println(cursorArray[l]);
		}

		// file close
		output.close();
	}

}